#include <stdio.h>
#include <mqueue.h>
#include <stdlib.h>

mqd_t server_q;
mqd_t client_q;

void init()
{
  server_q = mq_open("/server.mq", O_WRONLY);
  if (server_q < 0) {
    perror("Could not open server queue");
    exit(-1);
  }
  client_q = mq_open("/client.mq", O_RDONLY);
  if (client_q < 0) {
    perror("Could not open client queue");
    exit(-1);
  }
}

void synch()
{
  int d;
  int prio = 5;

  mq_send(server_q, (char *)&d, sizeof(int), prio);

  mq_receive(client_q, (char *)&d, sizeof(int), &prio);
}

void close()
{
  mq_close(server_q);
  mq_close(client_q);
}

int main()
{

  init();

  printf("Before synchronizazion\n");

  synch();

  printf("After synchronizazion\n");

  close();
}
