#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>

class SynchObj {
	pthread_barrier_t barrier;
public:
	SynchObj(int n)
	{
		pthread_barrier_init(&barrier, 0, n);
	}

	void synch() 
	{
		pthread_barrier_wait(&barrier);	
	}
};

void *thread_body(void *arg)
{
  SynchObj *s = (SynchObj *)arg;

  printf("Before the synchronization point...\n");

  s->synch();

  printf("After the synchronization point!\n");
}

int main(int argc, char *argv[])
{
  pthread_t *array;
  int i;

  if (argc < 2) {
    printf("Usage: %s <nthreads>\n", argv[0]);
    exit(0);
  }
  int n = atoi(argv[1]);
  printf("Example with %d threads\n", n);
  
  array = new pthread_t[n];

  SynchObj my_synch(n);

  for(i=0; i<n; i++) 
    pthread_create(&array[i], 0, thread_body, (void *)(&my_synch));
  
  for (i=0; i<n; i++) 
    pthread_join(array[i], 0);
}
