#include <iostream>
#include <pthread.h>
#include <semaphore.h>
#include "bridge.hpp"

#define MAXCARS    5

Bridge::Bridge()
{
  numCars = 0;
  sem_init(&carsOnBridge, 0, 1);
  sem_init(&bridgeFull, 0, MAXCARS);
  sem_init(&bridgeOpen, 0, 1);
  sem_init(&mutex, 0, 1);
}

void Bridge::request_open()
{
  sem_wait(&bridgeOpen);
  sem_wait(&carsOnBridge);
}

void Bridge::close()
{
  sem_post(&carsOnBridge);
  sem_post(&bridgeOpen);
}

void Bridge::enter()
{
  sem_wait(&bridgeFull);
  sem_wait(&bridgeOpen);
  sem_wait(&mutex);
  if (numCars == 0) sem_wait(&carsOnBridge);
  numCars++;
  sem_post(&bridgeOpen);
  sem_post(&mutex);
}

void Bridge::exit()
{
  sem_wait(&mutex);
  numCars--;
  if (numCars == 0) sem_post(&carsOnBridge);
  sem_post(&bridgeFull);
  sem_post(&mutex);
}
