#include <mqueue.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "barber.h"

int main()
{
	mqd_t server_q;
	mqd_t client_q;
	char client_name[50];
	int ret;
	struct mq_attr ma;

	ma.mq_flags = 0;
	ma.mq_maxmsg = 10;
	ma.mq_msgsize = sizeof(struct resp);

	// create client queue
	sprintf(client_name, "/client%d.mq", getpid());

	client_q = mq_open(client_name,
  		  O_RDONLY | O_CREAT, S_IRUSR | S_IWUSR | S_IXUSR,
  		  &ma);

	if (client_q < 0) sys_err("Cannot creare client queue");

	// open server queue

	server_q = mq_open(BARBER_QUEUE_NAME, O_WRONLY);

	if (server_q < 0) sys_err("Cannot create server queue");

	// create message

	struct req myreq; 
	strcpy(myreq.client_name, client_name);
	myreq.type = 0;

	// send request
	ret = mq_send(server_q, (char *)&myreq, sizeof(struct req), 1);

	if (ret < 0) sys_err("Error in sending");

	// wait for response
	struct resp myresp;
	unsigned prio;

	ret = mq_receive(client_q, (char *)&myresp, sizeof(struct resp), &prio);

	if (ret < 0) sys_err("Error in receiving");

	if (myresp.seat < 0) {
		printf("CUST %d: ALL FULL! exiting\n", getpid());
	}
	else {
		printf("CUST %d: Served in seat %d\n", getpid(), myresp.seat);
		sleep(2);
		printf("CUST %d: Finished, now exiting\n", getpid());
		myreq.type = 1;
		ret = mq_send(server_q, (char *)&myreq, sizeof(struct req), 1);
		if (ret < 0) sys_err("Error in sending!");
	}

	// now, close everything
	mq_close(server_q);
	mq_close(client_q);

	mq_unlink(client_name);
} 
